* THIS IS A SIMPLE BROWSE UTILITY THAT ALLOWS USERS TO SET UP THEIR OWN BROWSE WINDOWS.
* IT SHOULD BE EASY TO INTEGRATE BRWSUTIL WITH YOUR EXISTING APPLICATIONS -
* NO 'SET' COMMANDS ARE USED (EXCEPT ORDER, TALK, AND PRINTER - THEY ARE THEN RESTORED) -
* NO 'ON X' COMMANDS, AND NO PUBLIC VARIABLES ARE USED.
* IF A FILE IS OPEN AT STARTUP, IT IS RESELECTED AND THE ORDER RESTORED BEFORE RETURNING.
* BRWSUTIL REQUIRES THE FOLLOWING FILES:
* BRWSETUP.DBF,BRWSETUP.CDX,BRWSETUP.FPT,DBFSTRC.DBF,DBFSTRC.CDX,FLDSTRC.DBF,FLDSTRC.CDX,
* SPCSTRC.DBF,SPCSTRC.CDX,SPCSTRC.FPT.
* USING THE PROGRAM IS SIMPLE - EITHER CREATE A NEW SETUP OR USE AN EXISTING ONE.
* TO CREATE A NEW ONE, JUST PUT AN X NEXT TO THE DESIRED FIELD AND FILL IN FROM-TO VALUES (OPTIONAL).
* TO USE A SETUP, JUST ARROW TO IT AND HIT ESCAPE. A SCREEN FOR ENTERING TEMPORARY FROM-TO VALUES
* (TO BE IN EFFECT FOR JUST THIS ONE TIME) WILL APPEAR BEFORE ENTERING THE BROWSE WINDOW.
* AFTER ESCAPING FROM THE BROWSE WINDOW, THE PROGRAM WILL ASK IF YOU WANT TO PRINT A LIST.
* (C) COPYRIGHT 1994. NO WARRANTIES EXPRESSED OR IMPLIED AND LIKE THAT THERE.
* ANOTHER FINE (?) PROGRAM FROM
* THE COLSTEN COMPUTER COUNCIL, 244 RED BUD ROAD, CHICORA, PA 16025

IF SET("TALK") = "ON"
   SET TALK OFF
   SVTALKLLC = "ON"
ELSE
   SVTALKLLC = "OFF"
ENDIF   

* SAVE CURRENT TABLE AND ORDER TO RESTORE
SVALIASLLC = ALIAS()
SVORDERLLC = ORDER()
DEFINE WINDOW BRWINLLC FROM 1,0 TO 24,79

* SHOW MAIN SELECTION SCREEN
USE BRWSETUP IN 0 ORDER 1
SELECT BRWSETUP

DO WHILE BRWNAMELLC <> " EXIT THIS SCREEN"

   BROWSE NORMAL WINDOW BRWINLLC TITLE "USE ARROW KEYS TO SELECT CHOICE. ESCAPE TO CONTINUE.";
      FIELDS BRWNAMELLC :H = "SETUP NAME",;
             BRWFILNLLC :H = "FILENAME",;
             BRWSORTLLC :H = "SORTED BY",;
             BRWFLDLLLC,;
             BRWFRTOLLC,;
             BRWSAVFLLC,;
             BRWREPHLLC,;
             BRWNFLDLLC

   DO CASE
      CASE BRWNAMELLC = " CREATE NEW SETUP"
         DO CRNEWLLC
      CASE BRWNAMELLC <> " EXIT THIS SCREEN"
         DO USEEXLLC
   ENDCASE        
   
ENDDO   

* CLOSE BRWSETUP
USE

* RESTORE CURRENT FILE
IF SVALIASLLC > " "
   SELECT (SVALIASLLC)
ENDIF   
IF SVORDERLLC > " "
   SET ORDER TO SVORDERLLC
ENDIF   

* END
RELEASE WINDOW BRWINLLC
SET TALK &SVTALKLLC
RETURN

*** CREATE A NEW SETUP SUBROUTINE
FUNCTION CRNEWLLC

* DELETE FILES FIRST TO AVOID MESSAGES
DELETE FILE DBFLIST.TXT
DELETE FILE DBFLIST.DBF
DELETE FILE DBFLIST.CDX
FILNAMLLC = ""

* THIS IS A WAY TO CREATE AN EMPTY FILE WITHOUT ZAP OR DELETE & PACK
USE DBFSTRC IN 0
SELECT DBFSTRC
COPY TO DBFLIST WITH CDX

* CLOSE DBFSTRC
USE

USE DBFLIST IN 0 ORDER 1
SELECT DBFLIST

* OPEN SPECIAL FILE TO SEE IF SPCNLSTLLC FIELD (DONT LIST) IS CHECKED
USE SPCSTRC IN 0 ORDER 1
SELECT SPCSTRC

* STORE DBF FILENAMES 1 BY 1 AFTER VALIDITY CHECK
FILNAMLLC = SYS(2000,"*.DBF")
DO WHILE .T.

   * IF FILENAME IS NOT LISTED IN SPCSTRC OR IF NO LIST FLAG IS NOT ON (I LOVE DOUBLE NEGATIVES), THEN INSERT INTO DBFLIST
   IF ( SEEK(FILNAMLLC) = .F. ) OR ( ( SEEK(FILNAMLLC) = .T. ) AND ( SPCNLSTLLC <> .T. ) )
      INSERT INTO DBFLIST (DBFFORILLC) VALUES (FILNAMLLC)
   ENDIF

   * GET NEXT DBF FILENAME
   FILNAMLLC = SYS(2000,"*.DBF",1)

   IF FILNAMLLC < " "
      EXIT
   ENDIF   

ENDDO

* CLOSE SPCSTRC
USE

SELECT DBFLIST
GO TOP

* BROWSE DBFLIST TO PICK WHICH FILE
BROWSE NORMAL WINDOW BRWINLLC TITLE "USE ARROW KEYS TO SELECT DESIRED FILE. ESCAPE TO CONTINUE.";
   FIELDS DBFFORILLC :H = "FILENAME"
FILNAMLLC = RTRIM(DBFFORILLC)

* CLOSE DBFLIST
USE

* DELETE TEMPORARY FILES
DELETE FILE DBFLIST.TXT
DELETE FILE DBFLIST.DBF
DELETE FILE DBFLIST.CDX

* DELETE FILES FIRST TO AVOID MESSAGES
DELETE FILE FLDSEX.DBF
DELETE FILE FLDLIST.DBF
DELETE FILE FLDLIST.CDX

* THIS IS A WAY TO CREATE AN EMPTY FILE WITHOUT ZAP OR DELETE & PACK
USE FLDSTRC IN 0
SELECT FLDSTRC
COPY TO FLDLIST WITH CDX

* CLOSE FLDSTRC
USE

* OPEN FLDLIST 
USE FLDLIST IN 0 ORDER 1

* SELECT DESIRED FILE ROUTINE
FILUSEDLLC = .F.

* CHECK TO SEE IF FILE IS ALREADY USED
FOR I = 1 TO (SELECT(1))
   IF RIGHT(DBF(I), LEN(FILNAMLLC)) = FILNAMLLC
      FILUSEDLLC = .T.
      EXIT
   ENDIF
ENDFOR      

* IF NOT ALREADY USED
IF FILUSEDLLC = .F.
   USE (FILNAMLLC) IN 0
ENDIF   

SELECT (FILNAMLLC)
CURALILLC = ALIAS()

* CREATES A FILE WITH A LIST OF FIELDS
COPY STRUCTURE EXTENDED TO FLDSEX

* TRANSFER FILNAMLLC FIELD NAMES TO FLDLIST
SELECT FLDLIST
APPEND FROM FLDSEX

* THIS IS A WAY TO CREATE AN EMPTY FILE WITHOUT ZAP OR DELETE & PACK
USE DBFSTRC IN 0
SELECT DBFSTRC
COPY TO DBFLIST WITH CDX

* CLOSE DBFSTRC
USE

SELECT (FILNAMLLC)

* USE DBFLIST TO HOLD INDEX TAG NAMES - USE DBFLIST STATEMENT NOT NEEDED
FOR I = 1 TO 256
   IF EMPTY(TAG(I))
      EXIT
   ENDIF   
   INSERT INTO DBFLIST (DBFFORILLC) VALUES (TAG(I,CURALILLC))
NEXT I

* CLOSE FILNAMLLC 
IF FILUSEDLLC = .F.
   USE
ENDIF

* SET UP BROWSE WINDOW FOR CHOOSING DESIRED FIELDS, FROMTO VALUES
SELECT FLDLIST
GO TOP
FLDORDLLC = 0
BROWSE NORMAL WINDOW BRWINLLC TITLE "PUT X NEXT TO DESIRED FIELD,ENTER FROM-TO VALUES. ESCAPE TO CONTINUE.";
   FIELDS FIELD_NAME :R,;
   FLDXLLC :V = INCFLDOLLC() :H = "X",;
   FLDFRMVLLC :H = "SHOW NO RECORDS LESS THAN",;
   FLDTOVLLC :H = "SHOW NO RECORDS GREATER THAN      "

* SHOW LIST OF INDEX TAG NAMES IF THERE IS AT LEAST ONE
IF USED("DBFLIST")

   * BROWSE WINDOW FOR INDEX TAG NAMES
   SELECT DBFLIST
   SET ORDER TO 1
   BROWSE NORMAL WINDOW BRWINLLC TITLE "USE ARROW KEYS TO SELECT DESIRED INDEX TAG (SORTBY). ESCAPE TO CONTINUE.";
      FIELDS DBFFORILLC :H = "SORT BY"

   * SAVE INDEX TAG NAME
   SORTBYLLC = DBFFORILLC

   * CLOSE DBFLIST
   USE
ELSE
   SORTBYLLC = ""   
ENDIF

* DELETE TEMPORARY FILES
DELETE FILE DBFLIST.DBF
DELETE FILE DBFLIST.CDX

FLDLISLLC = ""
COMSTRLLC = ""
FROMTOLLC = ""
ANDSTRLLC = ""
REPHEADLLC = ""
NFLDLISLLC = ""
NCOMSTRLLC = ""

* GO THRU FIELD LIST IN CHOSEN ORDER
SELECT FLDLIST
SET ORDER TO 2

* SAVE REQUESTED INFO
SCAN

   * CREATE FIELD LIST, REPORT HEADER, NUMERIC FIELD LIST
   IF FLDXLLC > " "

      * CREATE FIELD LIST
      FLDLISLLC = FLDLISLLC + COMSTRLLC + RTRIM(FIELD_NAME)
        
      * CREATE REPORT HEADER
      REPHEADLLC = REPHEADLLC + LEFT(RTRIM(FIELD_NAME),FIELD_LEN) + " "
      FOR I = 1 TO (FIELD_LEN - LEN(RTRIM(FIELD_NAME)))
         REPHEADLLC = REPHEADLLC + " "
      NEXT I         

      * CREATE FIELD STRING OF NUMERIC FIELDS FOR TOTALS
      IF FIELD_TYPE = "N"
         NFLDLISLLC = NFLDLISLLC + NCOMSTRLLC + RTRIM(FIELD_NAME)
         
         * AFTER FIRST ONE SET COMMA STRING TO ", "
         NCOMSTRLLC = ", "
      ENDIF   

      * AFTER FIRST ONE SET COMMA STRING TO ", "
      COMSTRLLC = ", "      
   ENDIF   

   * CHARACTER & DATE TYPE FIELDS MUST HAVE DELIMITERS
   DO CASE
      CASE FIELD_TYPE = "C"
         DELIM1LLC = '"'
         DELIM2LLC = '"'
      CASE FIELD_TYPE = "D"
         DELIM1LLC = "{"
         DELIM2LLC = "}"
      OTHERWISE
         DELIM1LLC = ""
         DELIM2LLC = ""   
   ENDCASE     

   * CREATE FROM-TO LIST 
   IF ( FLDFRMVLLC > " " ) OR ( FLDTOVLLC > " " )      
      FROMTOLLC = FROMTOLLC + ANDSTRLLC + "BETWEEN(" + RTRIM(FIELD_NAME) + "," + DELIM1LLC + RTRIM(FLDFRMVLLC) + DELIM2LLC + "," + DELIM1LLC + RTRIM(FLDTOVLLC) + DELIM2LLC + ")"
      
      * AFTER FIRST ONE SET AND STRING TO "AND "
      ANDSTRLLC = " AND "      
   ENDIF
   
ENDSCAN      

* CLOSE FLDLIST
USE

* DELETE TEMPORARY FILES
DELETE FILE FLDSEX.DBF
DELETE FILE FLDLIST.DBF
DELETE FILE FLDLIST.CDX

* ADD A RECORD FOR NEWLY CREATED FIELD LIST
SELECT BRWSETUP

IF FLDLISLLC > " "
   APPEND BLANK
   REPLACE BRWNAMELLC WITH "ZZZ"
   REPLACE BRWFILNLLC WITH FILNAMLLC
   REPLACE BRWSORTLLC WITH SORTBYLLC
   REPLACE BRWFLDLLLC WITH FLDLISLLC
   IF FROMTOLLC > " "
      REPLACE BRWFRTOLLC WITH ( " FOR " + FROMTOLLC )
   ENDIF   
   REPLACE BRWREPHLLC WITH REPHEADLLC
   REPLACE BRWNFLDLLC WITH NFLDLISLLC
   WAIT WINDOW NOWAIT "PLEASE CHANGE ZZZ IN THE NAME COLUMN TO YOUR DESIRED NEW NAME"
ENDIF   
RETURN

*** DISPLAY BROWSE WINDOW USING EXISTING SETUP
FUNCTION USEEXLLC

* SAVE CHOSEN FILE AND FIELDS FROM BRWSETUP
FILNAMLLC = RTRIM(BRWFILNLLC)
FLDLISLLC = BRWFLDLLLC
FROMTOLLC = BRWFRTOLLC
SORTBYLLC = BRWSORTLLC
SAVETOLLC = BRWSAVFLLC
REPHEADLLC = BRWREPHLLC
NFLDLISLLC = BRWNFLDLLC

* OPEN SPCSTRC TO CHECK FILENAME AND TO GET SPCADINLLC FIELD (ADDITIONAL INSTRUCTIONS)
USE SPCSTRC IN 0 ORDER 1
SELECT SPCSTRC

* CHECK TO SEE IF A USER MANUALLY CHANGED FILENAME IN BRWSETUP
SEEK(FILNAMLLC)
IF ( FOUND() ) AND ( SPCNLSTLLC = .T. )
   WAIT WINDOW "FILE ACCESS DENIED - SHAME ON YOU!"
   USE
   SELECT BRWSETUP
   RETURN
ENDIF

* SAVE ADDITIONAL INSTRUCTIONS AND THEN CLOSE SPCSTRC
ADDINSTLLC = SPCADINLLC
USE

* SELECT DESIRED FILE ROUTINE
FILUSEDLLC = .F.

* CHECK TO SEE IF FILE IS ALREADY USED
FOR I = 1 TO (SELECT(1))
   IF RIGHT(DBF(I), LEN(FILNAMLLC)) = FILNAMLLC
      FILUSEDLLC = .T.
      EXIT
   ENDIF
ENDFOR      

* IF NOT ALREADY USED
IF FILUSEDLLC = .F.
   USE (FILNAMLLC) IN 0
ENDIF   

* CREATES A FILE WITH A LIST OF FIELDS
SELECT (FILNAMLLC)
COPY STRUCTURE EXTENDED TO FLDSEX

* THIS IS A WAY TO CREATE AN EMPTY FILE WITHOUT ZAP OR DELETE & PACK
USE FLDSTRC IN 0
SELECT FLDSTRC
COPY TO FLDLIST WITH CDX

* CLOSE FLDSTRC
USE

* OPEN FLDLIST AND APPEND INTO IT FIELD NAME FOR FILNAMLLC 
USE FLDLIST IN 0 ORDER 1
SELECT FLDLIST
APPEND FROM FLDSEX

* SET UP BROWSE WINDOW TO FILL IN
GO TOP
BROWSE NORMAL WINDOW BRWINLLC TITLE "ENTER TEMPORARY FROM-TO VALUES FOR JUST THIS TIME. ESCAPE TO CONTINUE.";
   FIELDS FIELD_NAME :R,;
   FLDFRMVLLC :H = "SHOW NO RECORDS LESS THAN",;
   FLDTOVLLC :H = "SHOW NO RECORDS GREATER THAN      "

TEMPFTLLC = ""
ANDSTRLLC = ""

* CREATE TEMPORARY FROM TO STRING
SCAN

   * CHARACTER & DATE TYPE FIELDS MUST HAVE DELIMITERS
   DO CASE
      CASE FIELD_TYPE = "C"
         DELIM1LLC = '"'
         DELIM2LLC = '"'
      CASE FIELD_TYPE = "D"
         DELIM1LLC = "{"
         DELIM2LLC = "}"
      OTHERWISE
         DELIM1LLC = ""
         DELIM2LLC = ""   
   ENDCASE     

   * SAVE TEMPORARY FROM-TO LIST 
   IF ( FLDFRMVLLC > " " ) OR ( FLDTOVLLC > " " )      
      TEMPFTLLC = TEMPFTLLC + ANDSTRLLC + "BETWEEN(" + RTRIM(FIELD_NAME) + "," + DELIM1LLC + RTRIM(FLDFRMVLLC) + DELIM2LLC + "," + DELIM1LLC + RTRIM(FLDTOVLLC) + DELIM2LLC + ")"
      
      * AFTER FIRST ONE SET AND STRING TO "AND "
      ANDSTRLLC = " AND "      
   ENDIF
   
ENDSCAN      

* CLOSE FLDLIST
USE

* DELETE TEMPORARY FILES
DELETE FILE FLDSEX.DBF
DELETE FILE FLDLIST.DBF
DELETE FILE FLDLIST.CDX

* ADJUST SETUP FROM TO WITH TEMPORARY FROM TO VALUES
DO CASE
   CASE ( FROMTOLLC > "  " ) AND ( TEMPFTLLC > " " )
      FROMTOLLC = FROMTOLLC + " AND " + TEMPFTLLC
   CASE ( FROMTOLLC <= " " ) AND ( TEMPFTLLC > " " )
      FROMTOLLC = " FOR " + TEMPFTLLC
ENDCASE         
     
* SELECT THE DESIRED FILE AND SET ORDER
SELECT (FILNAMLLC)
IF SORTBYLLC > " "
   SET ORDER TO SORTBYLLC
ENDIF   

* YOUR WAY RIGHT AWAY
WAIT ( "THERE ARE " + LTRIM(STR(RECCOUNT())) + " RECORDS IN THIS FILE" ) WINDOW NOWAIT
BROWSE NORMAL WINDOW BRWINLLC FIELDS &FLDLISLLC &FROMTOLLC &ADDINSTLLC

* COPY TO A FILE IF ONE WAS REQUESTED
IF SAVETOLLC > " "
   COPY TO (SAVETOLLC) FIELDS &FLDLISLLC &FROMTOLLC
ENDIF   

* PRINT A LIST
WAIT "DO YOU WANT TO PRINT A LIST (Y/N)" TO PRINTLLC WINDOW
IF UPPER(PRINTLLC) = "Y"
   
   * SAVE CURRENT PRINTER STATUS
   SVPRSTALLC = SET("PRINTER")

   * CHANGE ANY CALCULATED FIELDS (WHICH MAY HAVE BEEN TYPED IN MANUALLY) FROM FORM (A = B * C) TO FORM (B * C) FOR PRINTING
   LASTCOMLLC = 0
   FOR I = 1 TO LEN(FLDLISLLC)
      IF SUBSTR(FLDLISLLC,I,1) = ","
         LASTCOMLLC = I
      ENDIF
      IF SUBSTR(FLDLISLLC,I,1) = "="
         FLDLISLLC = STUFF(FLDLISLLC, LASTCOMLLC + 1, I - LASTCOMLLC, "")
      ENDIF
   NEXT I   

   _PLINENO = 0
   SET PRINTER ON
   ? REPHEADLLC
   ? "" 

   * PRINT CHOSEN RECORDS AND FIELDS
   SCAN &FROMTOLLC
      IF _PLINENO > 54
         EJECT PAGE
         ? REPHEADLLC
         ? ""
      ENDIF   
      ? &FLDLISLLC
   ENDSCAN   

   * ONLY PRINT TOTALS FOR NUMERIC FIELDS
   IF NFLDLISLLC > " "
      ? ""
      ? "TOTALS"
      SET TALK ON
      SUM &NFLDLISLLC &FROMTOLLC
      SET TALK OFF
   ENDIF   
 
   * RESET PRINTER STATUS
   SET PRINTER &SVPRSTALLC
   
ENDIF   

* CLOSE FILNAMLLC
IF FILUSEDLLC = .F.
   USE
ENDIF   

* GO BACK TO MAIN WINDOW
SELECT BRWSETUP
RETURN

*** KEEP TRACK OF THE ORDER FIELDS ARE CHOSEN
FUNCTION INCFLDOLLC

FLDORDLLC = FLDORDLLC + 1
REPLACE FLDFORDLLC WITH FLDORDLLC
RETURN